/*
 * ts2vob - Convert MPEG Transport Stream to Program Stream for DVD-Video
 * Copyright (C) 2005 Martin Winken <martinwi@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

/* $Id: AudioAccessUnit.h,v 1.2 2006/07/20 16:14:55 martinwi Exp $ */

#ifndef AUDIOACCESSUNIT_H
#define AUDIOACCESSUNIT_H

#include "ts2vob.h"
#include "AccessUnit.h"
//#include "TimeStamp.h"

class AudioAccessUnit : public AccessUnit {
private:
    bool startNewPacket;

public:
    AudioAccessUnit(bytevec & data, const TimeStamp & PTS) :
        AccessUnit(data, PTS, PTS), startNewPacket(false) {}

    bool startPossible() const { return true; }
    void setFirstAfterCutMark() { startNewPacket = true; }
    void setEndMark() {}
    bool startNewPacketHere() const { return startNewPacket; }
    bool wantsNV_PCK() const { return false; }
    bool writeTimeStamp() const { return true; }
};

#endif
