/*
 * ts2vob - Convert MPEG Transport Stream to Program Stream for DVD-Video
 * Copyright (C) 2005 Martin Winken <martinwi@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

/* $Id: STDBuffer.h,v 1.2 2006/07/20 16:14:55 martinwi Exp $ */

#ifndef STDBUFFER_H
#define STDBUFFER_H

#include <list>
#include "ts2vob.h"
#include "TimeStamp.h"

class STDBuffer {
private:
    struct DataInBuffer {
        DataInBuffer(int s, const TimeStamp & t) : size(s), DTS(t) {};
        int size;
        TimeStamp DTS;
    };
    typedef std::list<DataInBuffer> bufferList;
    bufferList buffer;
    int bytesFree;
    TimeStamp minSCR;

public:
    STDBuffer(int size);
    void store(int size, const TimeStamp & DTS);
    TimeStamp getEarliestTime(int byteNeeded) const;
    void releaseUntil(const TimeStamp & SCR);
};

#endif
