/*
 * ts2vob - Convert MPEG Transport Stream to Program Stream for DVD-Video
 * Copyright (C) 2005 Martin Winken <martinwi@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

/* $Id: TransportStream.h,v 1.2 2006/07/20 16:14:55 martinwi Exp $ */

#ifndef TRANSPORTSTREAM_H
#define TRANSPORTSTREAM_H

#include "ts2vob.h"
class TSPacket;

class TransportStream {
public:
    enum {
        PacketSize = 188,
        SyncPackets = 5,
        BufferPackets = 5, /* >= SyncPackets */

        SyncByte = 0x47
    };

private:
    std::istream &in;
    uint8_t buffer[PacketSize*BufferPackets];
    uint8_t *bufferPtr;
    int bytesInBuffer;
    
    bool fillBuffer();

public:
    TransportStream(std::istream &in_);
    bool seekSync();
    bool getPacket(TSPacket &packet);
};

#endif
