/*
 * ts2vob - Convert MPEG Transport Stream to Program Stream for DVD-Video
 * Copyright (C) 2005 Martin Winken <martinwi@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

/* $Id: VideoAccessUnit.h,v 1.2 2006/07/20 16:14:55 martinwi Exp $ */

#ifndef VIDEOACCESSUNIT_H
#define VIDEOACCESSUNIT_H

#include <iostream>
#include "ts2vob.h"
#include "AccessUnit.h"
//#include "TimeStamp.h"

class VideoAccessUnit : public AccessUnit {
private:
    int GOPStartIndex, PICStartIndex, SeqEndStartIndex;

public:
    VideoAccessUnit(bytevec & data,
                    TimeStamp PTS, TimeStamp DTS,
                    int GOPStart, int PICStart, int SeqEnd) :
        AccessUnit(data, PTS, DTS),
        GOPStartIndex(GOPStart), PICStartIndex(PICStart),
        SeqEndStartIndex(SeqEnd) {}

    virtual bool startPossible() const;
    virtual void setFirstAfterCutMark();
    virtual void setEndMark();
    virtual bool startNewPacketHere() const;
    virtual bool wantsNV_PCK() const;
    virtual bool writeTimeStamp() const;

    int getFrameRateCode() const;
    int getTemporalReference() const;
    void setBrokenLink();
    void setBitRate(int bit_rate_value);
    void writeSequenceEndCode();
    bool isSequenceStart() const;
};

#endif
